/* Esercizio 4 di Esercizidi1-6-17
 Una queue e' un valore con le seguenti operazioni specifiche:
	add per aggiungere un elemento alla coda
	get per accedere il primo tra gli inseriti, non ancora rimossi
	remove per rimuovere il primo tra gli inseriti, non ancora rimossi
	size per conoscere quanti elementi sono ancora in coda
	empty per conoscere se la coda ha elementi
 Si chiede di:
 (a) Introdurre in Java, un API per un tipo astratto per queue polimorfe
	 Non-Modificabili
 (b) Definire un ADT, ImQueueADT.java, per tale API;
 (c) Definire gli additionals
 (d) Fornire AF e I  per ImQueueADT.java;
 (e) Definire un caso di uso ed applicare mostrando cosa produce 
	 l'esecutore
 (f) Provare la correttezza di I.
 */

import java.util.*;
import java.lang.*;

/* (a,b,c) */
interface ImQueueAPI<A> extends Cloneable{
    public ImQueueAPI<A> add(A x);
    public A get();
    public ImQueueAPI<A> remove();
	public int size();
    public boolean empty();
}

public class ImQueueADT<A> implements ImQueueAPI<A>{
	private A first;
    private ImQueueADT<A> rest;
	private int size;
	//metodi
	public ImQueueADT(){//for introducing empty queue
		size = 0;
	}
	public ImQueueADT<A> add(A x){//caratteristica di queue vs stack
		ImQueueADT<A> ret = new ImQueueADT<A>();
		if (first == null){ret.first = x; ret.rest = null; 
						   ret.size = 1; return ret;}
		if (rest == null) {ret.first = first;
						   ret.rest = new ImQueueADT<A>().add(x);
						   ret.size = 2;return ret;}
        ret.first = first;
        ret.rest = rest.add(x);
		ret.size = size+1;
		return ret;
	}
	public A get(){//restituisce null se vuota
		return first;
	}
	public ImQueueADT<A> remove(){//restituisce null se vuota
		return rest;
	}
	public int size(){		
		return size;
	}
	public boolean empty(){		
		return (size == 0);
	}
	//additionals
	public boolean equals(Object o){
		ImQueueADT<?> myO = null;
		try {
			myO = (ImQueueADT<?>)o;
		}
		catch (Exception e) {return false;}
		return (first.equals(myO.first) && rest.equals(myO.rest));
	}
	public ImQueueADT<A> clone(){
		ImQueueADT<A> ret = new ImQueueADT<A>();
		try {ret = (ImQueueADT<A>) super.clone();}
		catch (Exception e) {}
		ret.first = first;
		ret.rest = rest;
		ret.size = size;
		return ret;
	}
	public String toString(){
		if (size == 0) return "[]";
		String first = this.first.toString();
		if (size == 1) return ("["+first+"]");
		String rest = this.rest.toString();
		rest = rest.substring(1,rest.length()-1);
		return ("["+first+","+rest+"]");
	}
	public LinkedList<A> elements(){//wrong: to be modified
		return null;
	}	
}

/* (d)
 Sia [ImQueueADT<Ta>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]}, 
 l'insieme dei valori astratti definiti da ImQueueADT<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = [] if c.size = 0
 AF(c) = [v1,...,vk] if (c.size = k) & (k > 0) & c.first = v1
						& AF(c.rest) = [v2,...,vk] 
 I(c) = if (size = 0) then (first = null & rest = null)
        & if (size = 1) then (first != null & rest = null)
        & if (size > 1) then size = rest.size+1
 */

/* (e) */
class Main{
    public static void main(String[] args) throws Error{
        ImQueueADT<Integer> queue1 = 
				new ImQueueADT<Integer>().add(1).add(5);
        System.out.println("queue1.get() = " + queue1.get());
		ImQueueADT<Integer> queue2 = queue1;
		ImQueueADT<Integer> clone1 = queue1.clone();
		ImQueueADT<Integer> queue3 = queue2.add(12);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("queue3 = " + queue3.toString());		
		System.out.println("clone1 = " + clone1.toString());
		ImQueueADT<Integer> clone2 = clone1.remove();
		ImQueueADT<Integer> clone3 = clone1.remove();
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("queue3 = " + queue3.toString());		
		System.out.println("clone1 = " + clone1.toString());
		System.out.println("clone2 = " + clone2.toString());
		System.out.println("clone3 = " + clone3.toString());
		ImQueueADT<Integer> clone4 = clone1.add(7);
		ImQueueADT<Integer> clone5 = clone1.add(6);
		System.out.println("queue1 = " + queue1.toString());		
		System.out.println("queue2 = " + queue2.toString());		
		System.out.println("queue3 = " + queue3.toString());		
		System.out.println("clone1 = " + clone1.toString());
		System.out.println("clone2 = " + clone2.toString());
		System.out.println("clone3 = " + clone3.toString());
		System.out.println("clone4 = " + clone4.toString());
		System.out.println("clone5 = " + clone5.toString());
	}
}

/*
 bellia:~ marcobellia$ cd /Users/marcobellia/Dropbox/AAAAAAEsercizi10del1-6-17/JavaSoluzioni 
 bellia:JavaSoluzioni marcobellia$ javac ImQueueADT.java -d ZcodeIQA/
 Note: ImQueueADT.java uses unchecked or unsafe operations.
 Note: Recompile with -Xlint:unchecked for details.
 bellia:JavaSoluzioni marcobellia$ cd ZcodeIQA/
 bellia:ZcodeIQA marcobellia$ java Main
 queue1.get() = 1
 queue1 = [1,5]
 queue2 = [1,5]
 queue3 = [1,5,12]
 clone1 = [1,5]
 queue1 = [1,5]
 queue2 = [1,5]
 queue3 = [1,5,12]
 clone1 = [1,5]
 clone2 = [5]
 clone3 = [5]
 queue1 = [1,5]
 queue2 = [1,5]
 queue3 = [1,5,12]
 clone1 = [1,5]
 clone2 = [5]
 clone3 = [5]
 clone4 = [1,5,7]
 clone5 = [1,5,6]
 bellia:ZcodeIQA marcobellia$ 
 */ 

/* (f) to e done */
 
 
