
/* Esercizio 3 di Esercizidel1-6-17
 In Esercizio 2 del 31-5-2017 abbiamo specializzato il tipo MuQueueADTX 
 di java nel tipo MuQSingleADTX per singolo accodamento in una codaPoli- 
 morfa e Mutable. Ora invece, vogliamo estendere il tipo MuQSingleADTX 
 con una nuova operazione:
		enque che dice quante volte uno stesso elemento \`e entrato in 
              coda (nel caso, dopo esserne precedentemente, uscito), 
			  accedendo al servizio offerto.
 Si chiede di:
 (a) Definire un ADT, MuQSingleADTXE che estenda MuQSingleADTX aggiun- 
	 gendo tale operazione;
 (b) Fornire gli additionals per MuQSingleADTXE;
 (c) Fornire AF e I  per MuQSingleADTXE; 
 (d) Fornire, compilare e eseduire un caso di uso
 */

import java.util.*;
import java.lang.*;

/* (a,b) */

class codeError extends RuntimeException{};

class record<A>{
	public A elem;
	public boolean in;
	public int k;
	public record(A e){
		elem = e; in = true; k = 1;
		//false is default for boolean fields;
		//0 is default for int fields
	}
}

// Usiamo record a 3 componenti per incrementare corettamente gli
// accessi. In particolare, "in" utilizzato, in add, per ontrolla-
// re che non si incrementi un accesso multiplo (di fatto non con-
// sentito dalla super-classe).
// In alternativa, all'uso di "in": In add per sapere se un oggetto
// e' davvero aggiunto in coda da super.add, possiamo misurare la
// coda prima e dopo l'esecuzione di super.add. Ovvero, modificare
// il corpo di add, dato sotto, in:
//     int temp = size();
//     super.add(x);
//     If(temp!=size())inOcc(x);
// Questo opera correttamente, non richiede l'uso di "in" ne' del
// metodo isInOcc. Ma utilizza un codice piuttosto vizioso e oscuro.
// Vedi MuQSingleADTXE2 perr una soluzione a 2 componenti che resa
// memo oscura da una definizione più strutturata del metodo add.


public class MuQSingleADTXE<A> extends MuQSingleADTX<A>{
    //State:
    private Vector<record<A>> occ;
	//Auxliary private metods for inspecting occ
	private void inOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			occ.get(i).in = true;
			occ.get(i).k++;
			return;
		}
		occ.add(new record<A>(e));
	}
	private void outOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			occ.get(i).in = false;
			return;
		}
		throw new codeError();
	}
	private int getOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			return (occ.get(i).k);
		}
		return 0;
	}
	private boolean isInOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			return (occ.get(i).in);
		}
		return false;
	}
	//Constructors and Methods
	public MuQSingleADTXE(){
		super();
        occ = new Vector<record<A>>();
	}
    public void add(A e){
        if (!isInOcc(e)){
            inOcc(e);
            super.add(e);//super.add non ha bisogno di isInOcc
                    //per controllare se aggiungere in coda.
                    //This invece, lo necessita per incrementare
        }
    }
	//public A get() -- inherited
	public void remove(){
		if (size()!=0) {
			outOcc(this.get());
			super.remove();
		}				
	}
	//public int size() -- inherited
	//public boolean empty() -- inherited
    public int enque(A x){
		return getOcc(x);
    }
	//additionals
	//equals ereditata da Object
	public MuQSingleADTXE<A> clone(){//it computes subtypes
        MuQSingleADTXE<A> ret = (MuQSingleADTXE<A>) super.clone();
        ret.occ = (Vector<record<A>>)occ.clone();
        return ret;
	}
	//public String toString() -- inherited
	//public LinkedList<A> elements() -- inherited
}

/* (c)
 Sia [MuQSingleADTX<A>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]},
 l'insieme dei valori astratti definiti da MuQueueADTX<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = AF[c.super]
 In effetti il valore espresso \`e definito dallo stato del super_oggetto.
 Per l'invariante invece, oltre a soddisfare l'invariante della super (com'e'
 ovvio), qui abbiamo alcune ulteriori propriet\`a:
 I(c) = forall i\in[0..elements.size()-1], 
				getOcc(element.get(i))>0 & isInOcc(element.get(i))
 */

