
/* Esercizio 3 (bis - soluzione alternativa) di Esercizidel1-6-17
 In Esercizio 2 del 31-5-2017 abbiamo specializzato il tipo MuQueueADTX 
 di java nel tipo MuQSingleADTX per singolo accodamento in una codaPoli- 
 morfa e Mutable. Ora invece, vogliamo estendere il tipo MuQSingleADTX 
 con una nuova operazione:
 enque che dice quante volte uno stesso elemento \`e entrato in 
 coda (nel caso, dopo esserne precedentemente, uscito), 
 accedendo al servizio offerto.
 Si chiede di:
 (a) Definire un ADT, MuQSingleADTXE che estenda MuQSingleADTX aggiun- 
 gendo tale operazione;
 (b) Fornire gli additionals per MuQSingleADTXE;
 (c) Fornire AF e I  per MuQSingleADTXE; 
 (d) Fornire, compilare e eseduire un caso di uso
 */

import java.util.*;
import java.lang.*;

/* (a,b) */

/* gia' dichiarata in MuQSingleADTXE 
 class codeError extends RuntimeException{};
*/ 

class record2<A>{
	public A elem;
	public int k;
	public record2(A e){
		elem = e; k = 1;
	}
}

// In MuQSingleADTXE usiamo record a 3 componenti per incrementare 
// correttamente in numero degli accessi. Il problema nasce nella
// definizione del corpo dell'overriding di "add": dobbiamo incre-
// mentare k se e solo se aggiungiamo un elemento. Come facciamo a
// sapere se l'elemento e' utilizzando le operazioni della super?
// La risposta ovvia e' utilizzare un metodo "add" che quando mo-
// lo stato di this, ovvero aggiunge un elemento, lo manifesti cal-
// il booleano "true" e calcolando false altrimenti. La super pero',
// non dispone di una tale "add" pubblica (e l'interaccia non la 
// prevede). Possiamo definirla noi a livello della nuova classe
// misurando la coda prima e dopo ogni "super.add".
// Otteniamo il seguente programma dove il riuso di "super.add" e'
// fatto nel metodo overloaded "add", richiamato nel metodo over-
// idden "add"



public class MuQSingleADTXE2<A> extends MuQSingleADTX<A>{
    //State:
    private Vector<record2<A>> occ;
	//Auxliary private metods for inspecting occ
	private void inOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			occ.get(i).k++;
			return;
		}
		occ.add(new record2<A>(e));
	}
	private int getOcc(A e){
		for(int i = 0; i < occ.size(); i++){
			if(!e.equals(occ.get(i).elem)) continue;
			return (occ.get(i).k);
		}
		return 0;
	}
	//Constructors and Methods
	public MuQSingleADTXE2(){
		super();
        occ = new Vector<record2<A>>();
	}
	private boolean add1(A x){
        int before = size();
            super.add(x);
		return (before!=size());
	}
	public void add(A x){
        if (add1(x))inOcc(x);
	}
	//public A get() -- inherited
	//public voi remove() -- inherited
	//public int size() -- inherited
	//public boolean empty() -- inherited
    public int enque(A x){
		return getOcc(x);
    }
	//additionals
	//equals ereditata da Object
	public MuQSingleADTXE2<A> clone(){//it computes subtypes
        MuQSingleADTXE2<A> ret = (MuQSingleADTXE2<A>) super.clone();
        ret.occ = (Vector<record2<A>>)occ.clone();
        return ret;
	}
	//public String toString() -- inherited
	//public LinkedList<A> elements() -- inherited
}

/* (c)
 Sia [MuQSingleADTX<A>]={[v1,...,vk] | (forall i\[1..k]) vi\in[Ta], Ta\in[A]},
 l'insieme dei valori astratti definiti da MuQueueADTX<Ta>, dove v1 e' first 
 ed e' il primo elemento inserito e non rimosso.
 AF(c) = AF[c.super]
 In effetti il valore espresso \`e definito dallo stato del super_oggetto.
 Per l'invariante invece, oltre a soddisfare l'invariante della super (com'e'
 ovvio), qui abbiamo alcune ulteriori propriet\`a:
 I(c) = forall i\in[0..elements.size()-1], 
						getOcc(element.get(i))>0 
 */

